Index: src/dvdcss/dvdcss.h
===================================================================
--- src/dvdcss/dvdcss.h	(Revision 254)
+++ src/dvdcss/dvdcss.h	(Arbeitskopie)
@@ -56,6 +56,7 @@
 #define DVDCSS_SEEK_KEY        (1 << 1)
 
 
+#if !defined(LIBDVDCSS_EXPORT)
 #if defined(LIBDVDCSS_EXPORTS)
 #define LIBDVDCSS_EXPORT __declspec(dllexport) extern
 #elif defined(LIBDVDCSS_IMPORTS)
@@ -63,6 +64,7 @@
 #else
 #define LIBDVDCSS_EXPORT extern
 #endif
+#endif /* !defined(LIBDVDCSS_EXPORT) */
 
 /*
  * Our version number. The variable name contains the interface version.
Index: configure.ac
===================================================================
--- configure.ac	(Revision 254)
+++ configure.ac	(Arbeitskopie)
@@ -185,6 +185,31 @@
 CFLAGS="${CFLAGS_save}"
 
 dnl
+dnl  Check if the compiler supports ELF visibility
+dnl
+CFLAGS_save="$CFLAGS"
+
+CFLAGS="$CFLAGS -fvisibility=hidden"
+AC_MSG_CHECKING([if \$CC supports ELF visibility])
+AC_COMPILE_IFELSE([
+AC_LANG_PROGRAM([[
+#pragma GCC visibility push(hidden)
+__attribute__((visibility("default")))
+int var=10;
+]])],
+[
+has_visibility=yes
+AC_DEFINE([LIBDVDCSS_EXPORT], [__attribute__((visibility("default"))) extern], [Symbol visibility prefix])
+],
+[
+has_visibility=no
+AC_DEFINE([EXPORT], [], [Symbol visibility prefix])
+CFLAGS="$CFLAGS_save"
+]
+)
+AC_MSG_RESULT($has_visibility)
+
+dnl
 dnl  Use 64 bits offsets
 dnl
 CFLAGS="-D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -DDVDCSS_DIST ${CFLAGS}"
